#!/usr/bin/perl
# Common Conversions
# Usage: Run this filter on selected text
# Copyright © 2017 by Mike Pasini
# Last Update: 29 August 2017

my $str = "";
my $calc = "";
my $ans = "";
undef $/;	 # returns are not end of records

if ($ENV{KMVAR_kmVar} ne "") {
	$str = $ENV{KMVAR_kmVar};
} else {
	$str = <STDIN>;
}

		# height/width calculation for resizing embedded videos
if ($str =~ /^width="(\d+?)" height="(\d+?)"/) {
	if ($1 eq "500") {
		$ans = sprintf("width=\"480\" height=\"%.0f\"", $2*480/$1);
	} else {
		$ans = sprintf("width=\"500\" height=\"%.0f\"", $2*500/$1);
	}
		# calculations (including formulas)
} elsif ($str =~ /[\+\-\*\/\(]/) {
	$ans = eval($str);
	if ($@) {
		$ans = $str;
	}
	# common conversions
} elsif ($str =~ /([,\.\d]+?) ?([a-z'"°FC]+?\.?) ?$/) {
	$calc = $1;
	$calc =~ s/,//g;
		# from foreign to local
		# from metric to imperial
	if ($str =~ /cm/) {
		$ans = eval($calc * 0.39370);
		$ans = sprintf("%.2f in.",$ans);
	} elsif ($str =~ /mm/) {
		$ans = eval($calc * 0.0393);
		$ans = sprintf("%.2f in.",$ans);
	} elsif ($str =~ /[^k]g/) {
		$ans = eval($calc * 0.035);
		$ans = sprintf("%.2f oz.",$ans);
	} elsif ($str =~ /kg/) {
		$ans = eval($calc * 2.2);
		$ans = sprintf("%.2f lbs.",$ans);
	} elsif ($str =~ /[^kcm]m$/) {
		if ($calc > 100) {
			$ans = eval($calc * 1.09361);
			$ans = sprintf("%.0f yards",$ans);
		} else {
			$ans = eval($calc * 3.28084);
			$ans = sprintf("%.2f ft.",$ans);
		}
	} elsif ($str =~ /km/) {
		$ans = eval($calc * 0.62137);
		$ans = sprintf("%.0f miles",$ans);
	} elsif ($str =~ /( ?)°C/) {
		$ans = eval(($calc * 1.8) + 32);
		$ans = sprintf("%.0f$1°F",$ans);
			# imperial conversions
	} elsif ($str =~ /ft/ || $str =~ /'/) {
		$ans = eval($calc * 0.3333);
		$ans = sprintf("%.2f yards",$ans);
			# if imperial, make metric
	} elsif ($str =~ /in/ || $str =~ /"/) {
		$ans = eval($calc * 2.54000);
		$ans = sprintf("%.2fcm",$ans);
	} elsif ($str =~ /oz/) {
		$ans = eval($calc * 0.02835);
		$ans = sprintf("%.2fkg",$ans);
	} elsif ($str =~ /miles/) {
		$ans = eval($calc * 1.60935);
		$ans = sprintf("%.0fkm",$ans);
	} elsif ($str =~ /lb/) {
		$ans = eval($calc * 0.45359);
		$ans = sprintf("%.2fkg",$ans);
	} elsif ($str =~ /yards/) {
		$ans = eval($calc * 0.91440);
		$ans = sprintf("%.0fm",$ans);
	} elsif ($str =~ /( ?)°F/) {
		$ans = eval(($calc - 32 )* 0.5555555);
		$ans = sprintf("%.0f$1°C",$ans);
	} else {
		$ans = $str;
	}
}
		# repeat original value if trailing space in selection
if ($ans ne $str && $str =~ / $/) {
	$str =~ s/ $//;
	$ans .= " ($str) ";
}
print $ans;